<?php
return  array(
    'columns'=>array(
        'desktop_stat_id'=>array(
            'type' => 'bigint',
            'unsigned' => true,
            'autoincrement' => true,
            'required' => true,
            'label' => 'id',
            'comment' => app::get('sysstat')->_('运营商统计id 自赠'),
            'order' => 1,
        ),
        'new_trade'=>array(
            'type' => 'number',
            'default' => 0,
            'label' => app::get('sysstat')->_('新增订单数'),
            'comment' => app::get('sysstat')->_('新增订单数'),
            'in_list'=>true,
            'default_in_list'=>true,
            'is_title' => true,
            'order' => 2,
        ),
        'new_fee'=>array(
            'type' => 'money',
            'default' => 0,
            'comment' => app::get('sysstat')->_('新增订单额'),
            'label' => app::get('sysstat')->_('新增订单额'),
            'in_list'=>true,
            'default_in_list'=>true,
            'is_title' => true,
            'order' => 3,
        ),
        'stats_trade_from' => array(
            'type' => array(
                'all' => app::get('systrade')->_('所有'),
                'pc' => app::get('systrade')->_('电脑端'),
                'wap' => app::get('systrade')->_('手机触屏'),
            ),
            'default' => 'all',
            'comment' => app::get('systrade')->_('统计来源'),
            'label' => app::get('sysstat')->_('统计来源'),
            'in_list'=>true,
            'default_in_list'=>true,
            'is_title' => true,
            'order' => 4,
        ),
        'refunds_num'=>array(
            'type' => 'number',
            'default' => 0,
            'label' => app::get('sysstat')->_('已退款的订单数量'),
            'comment' => app::get('sysstat')->_('已退款的订单数量'),
            'in_list'=>true,
            'default_in_list'=>true,
            'is_title' => true,
            'order' => 5,
        ),
        'refunds_fee'=>array(
            'type' => 'money',
            'default' => 0,
            'comment' => app::get('sysstat')->_('已退款的订单额'),
            'label' => app::get('sysstat')->_('已退款的订单额'),
            'in_list'=>true,
            'default_in_list'=>true,
            'is_title' => true,
            'order' => 6,
        ),
        'complete_trade'=>array(
            'type' => 'number',
            'default' => 0,
            'label' => app::get('sysstat')->_('已完成的订单数量'),
            'comment' => app::get('sysstat')->_('已完成的订单数量'),
            'in_list'=>true,
            'default_in_list'=>true,
            'is_title' => true,
            'order' => 7,
        ),
        'complete_fee'=>array(
            'type' => 'money',
            'default' => 0,
            'comment' => app::get('sysstat')->_('已完成订单额'),
            'label' => app::get('sysstat')->_('已完成订单额'),
            'in_list'=>true,
            'default_in_list'=>true,
            'is_title' => true,
            'order' => 8,
        ),
        'createtime'=>array(
            'type'=>'time',
            'comment' => app::get('sysstat')->_('创建时间'),
            'label' => app::get('sysstat')->_('创建时间'),
            'in_list'=>true,
            'default_in_list'=>true,
            'is_title' => true,
            'filtertype' => true,
            'filterdefault' => true,
            'order' => 9,
        ),
    ),
    'primary' => 'desktop_stat_id',
    'index' => array(
        'ind_createtime' => ['columns' => ['createtime']],
    ),
    'comment' => app::get('sysstat')->_('运营商交易统计表'),
);
